% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [r,p,flag] = getthreshold(R,v,tau_o)

Pb = 0.2;
n = 1000;
for im = 1:n
    r0(im) = R-v*tau_o+im*v*tau_o/n;
    left(im) = 1-1/pi*acos(2*r0(im)^2/R^2-(R^2-r0(im)^2-v^2*tau_o^2)^2/2/v^2/tau_o^2/R^2-1);
    diff(im) = abs(Pb-left(im));
    if im~=1
       if diff(im)<p
          p = diff(im);
          r = r0(im);  
          ik = im;
        end
    else
        p = diff(1);
        r = r0(1);
        ik = 1;
    end
end

% for im = 1:n
%     if ik == 1
%         r0(im) = r(ik)+im*1/n;
%     else
%     r0(im) = r(ik-1)+im*(r(ik+1)-r(ik-1))/n;
%     end
%     left(im) = 1-1/pi*acos(2*r0(im)^2/R^2-(R^2-r0(im)^2-v^2*tau_o^2)^2/2/v^2/tau_o^2/R^2-1);
%     diff(im) = abs(Pb-left(im));
%     if im~=1
%        if diff(im)<p
%           p = diff(im);
%           r = r0(im);  
%           ik = im;
%         end
%     else
%         p = diff(1);
%         r = r0(1);
%     end
% end
% 
% for im = 1:n
%     if ik == 1
%         r0(im) = r(ik)+im*1/n;
%     else
%     r0(im) = r(ik-1)+im*(r(ik+1)-r(ik-1))/n;
%     end
%     left(im) = 1-1/pi*acos(2*r0(im)^2/R^2-(R^2-r0(im)^2-v^2*tau_o^2)^2/2/v^2/tau_o^2/R^2-1);
%     diff(im) = abs(Pb-left(im));
%     if im~=1
%        if diff(im)<p
%           p = diff(im);
%           r = r0(im);  
%           ik = im;
%         end
%     else
%         p = diff(1);
%         r = r0(1);
%     end
% end


if p < 0.01
   flag = 1;
else
   r = R-v*tau_o;
   flag = 0;
end
        
    
    
